Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 3182)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 3183)
@@ -399,4 +399,95 @@
                         </grid>
                     </widget>
+                    <widget class="QGroupBox">
+                        <property name="name">
+                            <cstring>groupBox2</cstring>
+                        </property>
+                        <property name="title">
+                            <string>V&amp;RDP Authentication Library</string>
+                        </property>
+                        <hbox>
+                            <property name="name">
+                                <cstring>unnamed</cstring>
+                            </property>
+                            <property name="spacing">
+                                <number>5</number>
+                            </property>
+                            <widget class="QLineEdit">
+                                <property name="name">
+                                    <cstring>leVRDPLib</cstring>
+                                </property>
+                                <property name="whatsThis" stdset="0">
+                                    <string>Displays the path to the library that provides authentication for Remote Display (VRDP) clients.</string>
+                                </property>
+                            </widget>
+                            <widget class="QToolButton">
+                                <property name="name">
+                                    <cstring>tbSelectVRDPLib</cstring>
+                                </property>
+                                <property name="focusPolicy">
+                                    <enum>TabFocus</enum>
+                                </property>
+                                <property name="text">
+                                    <string></string>
+                                </property>
+                                <property name="iconSet">
+                                    <iconset>select_file_16px.png</iconset>
+                                </property>
+                                <property name="autoRaise">
+                                    <bool>true</bool>
+                                </property>
+                                <property name="whatsThis" stdset="0">
+                                    <string>Opens a dialog to select the VRDP authentication library file.</string>
+                                </property>
+                            </widget>
+                            <widget class="QToolButton">
+                                <property name="name">
+                                    <cstring>tbResetVRDPLib</cstring>
+                                </property>
+                                <property name="focusPolicy">
+                                    <enum>TabFocus</enum>
+                                </property>
+                                <property name="text">
+                                    <string></string>
+                                </property>
+                                <property name="iconSet">
+                                    <iconset>eraser_16px.png</iconset>
+                                </property>
+                                <property name="autoRaise">
+                                    <bool>true</bool>
+                                </property>
+                                <property name="whatsThis" stdset="0">
+                                    <string>Resets the authentication library file to the default value. The actual default library file will be displayed after accepting the changes and opening this dialog again.</string>
+                                </property>
+                            </widget>
+                        </hbox>
+                    </widget>
+                    <widget class="QGroupBox">
+                        <property name="name">
+                            <cstring>groupBox3</cstring>
+                        </property>
+                        <property name="title">
+                            <string>&amp;Extended Features</string>
+                        </property>
+                        <hbox>
+                            <property name="name">
+                                <cstring>unnamed</cstring>
+                            </property>
+                            <widget class="QCheckBox">
+                                <property name="name">
+                                    <cstring>chbVTX</cstring>
+                                </property>
+                                <property name="text">
+                                    <string>Enable &amp;VT-x/AMD-V</string>
+                                </property>
+                                <property name="accel">
+                                    <string>Alt+V</string>
+                                </property>
+                                <property name="whatsThis" stdset="0">
+                                    <string>Defines whether virtual machines should try to make use of the host CPU's hardware virtualization extensions such as Intel VT-x and AMD-V by default or not.</string>
+                                </property>
+                            </widget>
+                        </hbox>leVRDPLib
+                    </widget>
                     <spacer>
                         <property name="name">
@@ -1128,4 +1219,16 @@
     </connection>
     <connection>
+        <sender>tbResetVRDPLib</sender>
+        <signal>clicked()</signal>
+        <receiver>VBoxGlobalSettingsDlg</receiver>
+        <slot>tbResetFolder_clicked()</slot>
+    </connection>
+    <connection>
+        <sender>tbSelectVRDPLib</sender>
+        <signal>clicked()</signal>
+        <receiver>VBoxGlobalSettingsDlg</receiver>
+        <slot>tbSelectFolder_clicked()</slot>
+    </connection>
+    <connection>
         <sender>lvUSBFilters</sender>
         <signal>currentChanged(QListViewItem*)</signal>
@@ -1179,4 +1282,8 @@
     <tabstop>tbSelectMachineFolder</tabstop>
     <tabstop>tbResetMachineFolder</tabstop>
+    <tabstop>leVRDPLib</tabstop>
+    <tabstop>tbSelectVRDPLib</tabstop>
+    <tabstop>tbResetVRDPLib</tabstop>
+    <tabstop>chbVTX</tabstop>
     <tabstop>lvUSBFilters</tabstop>
     <tabstop>tbAddUSBFilter</tabstop>
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui.h	(revision 3182)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui.h	(revision 3183)
@@ -576,4 +576,10 @@
     leMachineFolder->setText (props.GetDefaultMachineFolder());
 
+    /* vrdp lib path */
+    leVRDPLib->setText (props.GetRemoteDisplayAuthLibrary());
+
+    /* VT-x/AMD-V */
+    chbVTX->setChecked (props.GetHWVirtExEnabled());
+
     /* proprietary GUI settings */
 
@@ -658,4 +664,11 @@
         props.SetDefaultMachineFolder (leMachineFolder->text());
 
+    /* vrdp lib path */
+    if (leVRDPLib->isModified())
+        props.SetRemoteDisplayAuthLibrary (leVRDPLib->text());
+
+    /* VT-x/AMD-V */
+    props.SetHWVirtExEnabled (chbVTX->isChecked());
+
     if (!props.isOk())
         return;
@@ -763,4 +776,5 @@
     if (tb == tbResetVDIFolder) le = leVDIFolder;
     else if (tb == tbResetMachineFolder) le = leMachineFolder;
+    else if (tb == tbResetVRDPLib) le = leVRDPLib;
     Assert (le);
 
@@ -781,4 +795,5 @@
     if (tb == tbSelectVDIFolder) le = leVDIFolder;
     else if (tb == tbSelectMachineFolder) le = leMachineFolder;
+    else if (tb == tbSelectVRDPLib) le = leVRDPLib;
     Assert (le);
 
@@ -786,18 +801,22 @@
     if (initDir.isNull())
         initDir = vboxGlobal().virtualBox().GetHomeFolder();
-    QString folder = VBoxGlobal::getExistingDirectory (initDir, this);
-    if (folder.isNull())
+
+    QString path = le == leVRDPLib ?
+        VBoxGlobal::getOpenFileName (initDir, QString::null, this,
+                                     "getFile", QString::null) :
+        VBoxGlobal::getExistingDirectory (initDir, this);
+    if (path.isNull())
         return;
 
-    folder = QDir::convertSeparators (folder);
+    path = QDir::convertSeparators (path);
     /* remove trailing slash if any */
-    folder.remove (QRegExp ("[\\\\/]$"));
+    path.remove (QRegExp ("[\\\\/]$"));
 
     /*
-     *  do this instead of le->setText (folder) to cause
+     *  do this instead of le->setText (path) to cause
      *  isModified() return true
      */
     le->selectAll();
-    le->insert (folder);
+    le->insert (path);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3182)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3183)
@@ -1109,4 +1109,21 @@
 the Input Output APIC (IO APIC), which may slightly decrease the VM performance. &lt;b&gt;Note:&lt;/b&gt; don't disable
 this feature after having installed a Windows guest operating system!&lt;/qt&gt;</string>
+                                                            </property>
+                                                        </widget>
+                                                        <widget class="QCheckBox">
+                                                            <property name="name">
+                                                                <cstring>chbVTX</cstring>
+                                                            </property>
+                                                            <property name="text">
+                                                                <string>Enable &amp;VT-x/AMD-V</string>
+                                                            </property>
+                                                            <property name="accel">
+                                                                <string>Alt+V</string>
+                                                            </property>
+                                                            <property name="tristate">
+                                                                <bool>true</bool>
+                                                            </property>
+                                                            <property name="whatsThis" stdset="0">
+                                                                <string>When checked, the virtual machine will try to make use of the host CPU's hardware virtualization extensions such as Intel VT-x and AMD-V. The third checkbox state means that this setting is determined by the value of the global setting.</string>
                                                             </property>
                                                         </widget>
@@ -2940,4 +2957,5 @@
     <tabstop>chbEnableACPI</tabstop>
     <tabstop>chbEnableIOAPIC</tabstop>
+    <tabstop>chbVTX</tabstop>
     <tabstop>cbSharedClipboard</tabstop>
     <tabstop>leSnapshotFolder</tabstop>
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 3182)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 3183)
@@ -1509,4 +1509,9 @@
     /* IO APIC */
     chbEnableIOAPIC->setChecked (biosSettings.GetIOAPICEnabled());
+
+    /* VT-x/AMD-V */
+    machine.GetHWVirtExEnabled() == CEnums::False ? chbVTX->setChecked (false) :
+    machine.GetHWVirtExEnabled() == CEnums::True ?  chbVTX->setChecked (true) :
+                                                    chbVTX->setNoChange();
 
     /* Saved state folder */
@@ -1843,4 +1848,9 @@
     biosSettings.SetIOAPICEnabled (chbEnableIOAPIC->isChecked());
 
+    /* VT-x/AMD-V */
+    cmachine.SetHWVirtExEnabled (
+        chbVTX->state() == QButton::Off ? CEnums::False :
+        chbVTX->state() == QButton::On ? CEnums::True : CEnums::Default);
+
     /* Saved state folder */
     if (leSnapshotFolder->isModified())