Index: trunk/src/VBox/Main/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 3277)
+++ trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 3278)
@@ -302,8 +302,6 @@
     AssertReturn (mConsoleVRDPServer, E_FAIL);
 
-#ifdef VRDP_MC
     mcAudioRefs = 0;
     mcVRDPClients = 0;
-#endif /* VRDP_MC */
 
     unconst (mVMMDev) = new VMMDev(this);
@@ -443,5 +441,4 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(int) Console::vrdp_ClientLogon (void *pvUser,
                                              uint32_t u32ClientId,
@@ -449,17 +446,7 @@
                                              const char *pszPassword,
                                              const char *pszDomain)
-#else
-DECLCALLBACK(int) Console::vrdp_ClientLogon (void *pvUser, const char *pszUser,
-                                             const char *pszPassword,
-                                             const char *pszDomain)
-#endif /* VRDP_MC */
 {
     LogFlowFuncEnter();
-#ifdef VRDP_MC
     LogFlowFunc (("%d, %s, %s, %s\n", u32ClientId, pszUser, pszPassword, pszDomain));
-#else
-    uint32_t u32ClientId = 0;
-    LogFlowFunc (("%s, %s, %s\n", pszUser, pszPassword, pszDomain));
-#endif /* VRDP_MC */
 
     Console *console = static_cast <Console *> (pvUser);
@@ -630,11 +617,6 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(void) Console::vrdp_ClientConnect (void *pvUser,
                                                 uint32_t u32ClientId)
-#else
-DECLCALLBACK(void) Console::vrdp_ClientConnect (void *pvUser,
-                                                uint32_t fu32SupportedOrders)
-#endif /* VRDP_MC */
 {
     LogFlowFuncEnter();
@@ -647,12 +629,8 @@
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
     ASMAtomicIncU32(&console->mcVRDPClients);
 
     NOREF(u32ClientId);
     console->mDisplay->VideoAccelVRDP (true);
-#else
-    console->mDisplay->VideoAccelVRDP (true, fu32SupportedOrders);
-#endif /* VRDP_MC */
 #endif /* VBOX_VRDP */
 
@@ -661,11 +639,7 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(void) Console::vrdp_ClientDisconnect (void *pvUser,
                                                    uint32_t u32ClientId,
                                                    uint32_t fu32Intercepted)
-#else
-DECLCALLBACK(void) Console::vrdp_ClientDisconnect (void *pvUser)
-#endif /* VRDP_MC */
 {
     LogFlowFuncEnter();
@@ -680,25 +654,15 @@
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
     ASMAtomicDecU32(&console->mcVRDPClients);
 
     console->mDisplay->VideoAccelVRDP (false);
-#else
-    u32ClientId = 0;
-    console->mDisplay->VideoAccelVRDP (false, 0);
-#endif /* VRDP_MC */
 #endif /* VBOX_VRDP */
 
-#ifdef VRDP_MC
     if (fu32Intercepted & VRDP_CLIENT_INTERCEPT_USB)
     {
         console->mConsoleVRDPServer->USBBackendDelete (u32ClientId);
     }
-#else
-    console->mConsoleVRDPServer->DeleteUSBBackend ();
-#endif /* VRDP_MC */
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
     if (fu32Intercepted & VRDP_CLIENT_INTERCEPT_CLIPBOARD)
     {
@@ -722,14 +686,4 @@
         }
     }
-#else
-    if (console->mAudioSniffer)
-    {
-        PPDMIAUDIOSNIFFERPORT port = console->mAudioSniffer->getAudioSnifferPort();
-        if (port)
-        {
-            port->pfnSetup (port, false, false);
-        }
-    }
-#endif /* VRDP_MC */
 #endif /* VBOX_VRDP */
 
@@ -749,10 +703,6 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(void) Console::vrdp_InterceptAudio (void *pvUser,
                                                  uint32_t u32ClientId)
-#else
-DECLCALLBACK(void) Console::vrdp_InterceptAudio (void *pvUser, bool fKeepHostAudio)
-#endif /* VRDP_MC */
 {
     LogFlowFuncEnter();
@@ -764,15 +714,9 @@
     AssertComRCReturnVoid (autoCaller.rc());
 
-#ifdef VRDP_MC
     LogFlowFunc (("mAudioSniffer %p, u32ClientId %d.\n",
                   console->mAudioSniffer, u32ClientId));
     NOREF(u32ClientId);
-#else
-    LogFlowFunc (("mAudioSniffer %p, keepHostAudio %d.\n",
-                  console->mAudioSniffer, fKeepHostAudio));
-#endif /* VRDP_MC */
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
     console->mcAudioRefs++;
 
@@ -788,14 +732,4 @@
         }
     }
-#else
-    if (console->mAudioSniffer)
-    {
-        PPDMIAUDIOSNIFFERPORT port = console->mAudioSniffer->getAudioSnifferPort();
-        if (port)
-        {
-            port->pfnSetup (port, true, !!fKeepHostAudio);
-        }
-    }
-#endif /* VRDP_MC */
 #endif
 
@@ -804,12 +738,8 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(void) Console::vrdp_InterceptUSB (void *pvUser,
                                                uint32_t u32ClientId,
                                                PFNVRDPUSBCALLBACK *ppfn,
                                                void **ppv)
-#else
-DECLCALLBACK(void) Console::vrdp_InterceptUSB (void *pvUser, PFNVRDPUSBCALLBACK *ppfn, void **ppv)
-#endif /* VRDP_MC */
 {
     LogFlowFuncEnter();
@@ -823,9 +753,5 @@
     AssertReturnVoid (console->mConsoleVRDPServer);
 
-#ifdef VRDP_MC
     console->mConsoleVRDPServer->USBBackendCreate (u32ClientId, ppfn, ppv);
-#else
-    console->mConsoleVRDPServer->CreateUSBBackend (ppfn, ppv);
-#endif /* VRDP_MC */
 
     LogFlowFuncLeave();
@@ -833,5 +759,4 @@
 }
 
-#ifdef VRDP_MC
 DECLCALLBACK(void) Console::vrdp_InterceptClipboard (void *pvUser,
                                                      uint32_t u32ClientId,
@@ -856,13 +781,4 @@
     return;
 }
-#else
-DECLCALLBACK(void) Console::vrdp_InterceptClipboard (void *pvUser,
-                                                     PFNVRDPCLIPBOARDCALLBACK *ppfn,
-                                                     void **ppv)
-{
-    /* Obsolete. */
-    return;
-}
-#endif /* VRDP_MC */
 
 
@@ -4229,12 +4145,4 @@
     ComAssertComRCRetRC (hrc);
 
-#ifndef VRDP_MC
-    if (fRemote)
-    {
-        pvRemote = mConsoleVRDPServer->GetUSBBackendPointer ();
-        ComAssertRet (pvRemote, E_FAIL);
-    }
-#endif /* !VRDP_MC */
-
     /* protect mpVM */
     AutoVMCaller autoVMCaller (this);
@@ -4306,5 +4214,4 @@
     AssertReturn (that && aConfig && aUuid, VERR_INVALID_PARAMETER);
 
-#ifdef VRDP_MC
     if (aRemote)
     {
@@ -4324,5 +4231,4 @@
         }
     }
-#endif /* VRDP_MC */
 
     int vrc = aConfig->pfnCreateProxyDevice (aConfig, aUuid, aRemote, aAddress,
@@ -4419,5 +4325,4 @@
     AssertReturn (that && aConfig && aUuid, VERR_INVALID_PARAMETER);
 
-#ifdef VRDP_MC
     /*
      * If that was a remote device, release the backend pointer.
@@ -4434,5 +4339,4 @@
         that->consoleVRDPServer ()->USBBackendReleasePointer (&guid);
     }
-#endif /* VRDP_MC */
 
     int vrc = aConfig->pfnDestroyProxyDevice (aConfig, aUuid);
@@ -6313,16 +6217,8 @@
  *  @note Locks this object for writing.
  */
-#ifdef VRDP_MC
 void Console::processRemoteUSBDevices (uint32_t u32ClientId, VRDPUSBDEVICEDESC *pDevList, uint32_t cbDevList)
-#else
-void Console::processRemoteUSBDevices (VRDPUSBDEVICEDESC *pDevList, uint32_t cbDevList)
-#endif /* VRDP_MC */
 {
     LogFlowThisFuncEnter();
-#ifdef VRDP_MC
     LogFlowThisFunc (("u32ClientId = %d, pDevList=%p, cbDevList = %d\n", u32ClientId, pDevList, cbDevList));
-#else
-    LogFlowThisFunc (("pDevList=%p, cbDevList = %d\n", pDevList, cbDevList));
-#endif /* VRDP_MC */
 
     AutoCaller autoCaller (this);
@@ -6369,10 +6265,6 @@
         while (it != mRemoteUSBDevices.end())
         {
-#ifdef VRDP_MC
             if ((*it)->devId () == e->id
                 && (*it)->clientId () == u32ClientId)
-#else
-            if ((*it)->devId () == e->id)
-#endif /* VRDP_MC */
             {
                /* The device is already in the list. */
@@ -6394,9 +6286,5 @@
             ComObjPtr <RemoteUSBDevice> device;
             device.createObject();
-#ifdef VRDP_MC
             device->init (u32ClientId, e);
-#else
-            device->init (e);
-#endif /* VRDP_MC */
 
             mRemoteUSBDevices.push_back (device);
Index: trunk/src/VBox/Main/ConsoleVRDPServer.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleVRDPServer.cpp	(revision 3277)
+++ trunk/src/VBox/Main/ConsoleVRDPServer.cpp	(revision 3278)
@@ -45,9 +45,5 @@
 void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPSendAudioSamples)(HVRDPSERVER hserver, void *pvSamples, uint32_t cSamples, VRDPAUDIOFORMAT format);
 void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPSendAudioVolume) (HVRDPSERVER hserver, uint16_t left, uint16_t right);
-#ifdef VRDP_MC
 void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPSendUSBRequest)  (HVRDPSERVER hserver, uint32_t u32ClientId, void *pvParms, uint32_t cbParms);
-#else
-void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPSendUSBRequest)  (HVRDPSERVER hserver, void *pvParms, uint32_t cbParms);
-#endif /* VRDP_MC */
 void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPSendUpdate)      (HVRDPSERVER hServer, unsigned uScreenId, void *pvUpdate, uint32_t cbUpdate);
 void (VBOXCALL *ConsoleVRDPServer::mpfnVRDPQueryInfo)       (HVRDPSERVER hserver, uint32_t index, void *pvBuffer, uint32_t cbBuffer, uint32_t *pcbOut);
@@ -59,5 +55,4 @@
     mConsole = console;
 
-#ifdef VRDP_MC
     int rc = RTCritSectInit (&mCritSect);
     AssertRC (rc);
@@ -74,9 +69,4 @@
     mUSBBackends.event = 0;
 #endif
-#else
-#ifdef VBOX_WITH_USB
-    mRemoteUSBBackend = NULL;
-#endif
-#endif /* VRDP_MC */
 
 #ifdef VBOX_VRDP
@@ -89,5 +79,4 @@
 ConsoleVRDPServer::~ConsoleVRDPServer ()
 {
-#ifdef VRDP_MC
     Stop ();
 
@@ -97,10 +86,4 @@
         memset (&mCritSect, 0, sizeof (mCritSect));
     }
-#else
-#ifdef VBOX_VRDP
-    Stop ();
-    /* No unloading of anything because we might still have live object around. */
-#endif
-#endif /* VRDP_MC */
 }
 
@@ -125,18 +108,6 @@
         if (VBOX_SUCCESS(rc))
         {
-#ifndef VRDP_MC
-            LogFlow(("VRDP server created: %p, will set mFramebuffer\n", mhServer));
-
-            IFramebuffer *framebuffer = mConsole->getDisplay()->getFramebuffer();
-
-            mpfnVRDPSetFramebuffer (mhServer, framebuffer,
-                framebuffer? VRDP_EXTERNAL_FRAMEBUFFER: VRDP_INTERNAL_FRAMEBUFFER);
-
-            LogFlow(("Framebuffer %p set for the VRDP server\n", framebuffer));
-#endif /* !VRDP_MC */
 #ifdef VBOX_WITH_USB
-#ifdef VRDP_MC
             remoteUSBThreadStart ();
-#endif /* VRDP_MC */
 #endif /* VBOX_WITH_USB */
         }
@@ -178,17 +149,5 @@
 
 #ifdef VBOX_WITH_USB
-#ifdef VRDP_MC
     remoteUSBThreadStop ();
-#else
-    /* Delete the USB backend object if it was not deleted properly. */
-    if (mRemoteUSBBackend)
-    {
-        Log(("ConsoleVRDPServer::Stop: deleting USB backend\n"));
-
-        mRemoteUSBBackend->ReleaseUSB ();
-        delete mRemoteUSBBackend;
-        mRemoteUSBBackend = NULL;
-    }
-#endif /* VRDP_MC */
 #endif /* VBOX_WITH_USB */
 
@@ -203,5 +162,4 @@
 }
 
-#ifdef VRDP_MC
 /* Worker thread for Remote USB. The thread polls the clients for
  * the list of attached USB devices.
@@ -248,10 +206,8 @@
 void ConsoleVRDPServer::notifyRemoteUSBThreadRunning (RTTHREAD thread)
 {
-#ifdef VBOX_WITH_USB
     mUSBBackends.thread = thread;
     mUSBBackends.fThreadRunning = true;
     int rc = RTThreadUserSignal (thread);
     AssertRC (rc);
-#endif
 }
     
@@ -321,5 +277,4 @@
 }
 #endif /* VBOX_WITH_USB */
-#endif /* VRDP_MC */
 
 VRDPAuthResult ConsoleVRDPServer::Authenticate (const Guid &uuid, VRDPAuthGuestJudgement guestJudgement,
@@ -448,5 +403,4 @@
 }
 
-#ifdef VRDP_MC
 int ConsoleVRDPServer::lockConsoleVRDPServer (void)
 {
@@ -876,50 +830,4 @@
 #endif
 }
-#else // VRDP_MC
-void ConsoleVRDPServer::CreateUSBBackend (PFNVRDPUSBCALLBACK *ppfn, void **ppv)
-{
-#ifdef VBOX_WITH_USB
-    Assert(mRemoteUSBBackend == NULL);
-
-    mRemoteUSBBackend = new RemoteUSBBackend (mConsole, this);
-
-    if (mRemoteUSBBackend)
-    {
-        int rc = mRemoteUSBBackend->InterceptUSB (ppfn, ppv);
-
-        if (VBOX_FAILURE (rc))
-        {
-            delete mRemoteUSBBackend;
-            mRemoteUSBBackend = NULL;
-        }
-    }
-#endif /* VBOX_WITH_USB */
-}
-
-void ConsoleVRDPServer::DeleteUSBBackend (void)
-{
-#ifdef VBOX_WITH_USB
-    LogFlow(("ConsoleVRDPServer::DeleteUSBBackend: %p\n", mRemoteUSBBackend));
-
-    if (mRemoteUSBBackend)
-    {
-        mRemoteUSBBackend->ReleaseUSB ();
-        delete mRemoteUSBBackend;
-        mRemoteUSBBackend = NULL;
-    }
-#endif /* VBOX_WITH_USB */
-}
-
-void *ConsoleVRDPServer::GetUSBBackendPointer (void)
-{
-#ifdef VBOX_WITH_USB
-    Assert (mRemoteUSBBackend); /* Must be called only if the object exists. */
-    return mRemoteUSBBackend->GetRemoteBackendCallback ();
-#else
-    return NULL;
-#endif 
-}
-#endif /* VRDP_MC */
-
 
 
@@ -972,5 +880,4 @@
 }
 
-#ifdef VRDP_MC
 void ConsoleVRDPServer::SendUSBRequest (uint32_t u32ClientId, void *pvParms, uint32_t cbParms) const
 {
@@ -980,13 +887,4 @@
 #endif
 }
-#else
-void ConsoleVRDPServer::SendUSBRequest (void *pvParms, uint32_t cbParms) const
-{
-#ifdef VBOX_VRDP
-    if (mpfnVRDPSendUSBRequest)
-        mpfnVRDPSendUSBRequest (mhServer, pvParms, cbParms);
-#endif
-}
-#endif /* VRDP_MC */
 
 void ConsoleVRDPServer::QueryInfo (uint32_t index, void *pvBuffer, uint32_t cbBuffer, uint32_t *pcbOut) const
@@ -1023,7 +921,4 @@
             {
                 DEFSYMENTRY(VRDPStartServer),
-#ifndef VRDP_MC
-                DEFSYMENTRY(VRDPSetFramebuffer),
-#endif /* VRDP_MC */
                 DEFSYMENTRY(VRDPSetCallback),
                 DEFSYMENTRY(VRDPShutdownServer),
Index: trunk/src/VBox/Main/DisplayImpl.cpp
===================================================================
--- trunk/src/VBox/Main/DisplayImpl.cpp	(revision 3277)
+++ trunk/src/VBox/Main/DisplayImpl.cpp	(revision 3278)
@@ -374,5 +374,4 @@
 }
 
-#ifndef VRDP_MC
 static void checkCoordBounds (int *px, int *py, int *pw, int *ph, int cx, int cy)
 {
@@ -407,5 +406,4 @@
     }
 }
-#endif
 
 unsigned mapCoordsToScreen(DISPLAYFBINFO *pInfos, unsigned cInfos, int *px, int *py, int *pw, int *ph)
@@ -454,9 +452,5 @@
 #endif /* DEBUG_sunlover */
 
-#ifdef VRDP_MC
     unsigned uScreenId = mapCoordsToScreen(maFramebuffers, mcMonitors, &x, &y, &w, &h);
-#else
-    checkCoordBounds (&x, &y, &w, &h, mpDrv->Connector.cx, mpDrv->Connector.cy);
-#endif /* VRDP_MC */
 
 #ifdef DEBUG_sunlover
@@ -482,4 +476,6 @@
 
         RTSemEventMultiReset(mUpdateSem);
+
+        checkCoordBounds (&x, &y, &w, &h, mpDrv->Connector.cx, mpDrv->Connector.cy);
 
         pFramebuffer->NotifyUpdate(x, y, w, h, &finished);
@@ -770,14 +766,8 @@
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
 /* Called always by one VRDP server thread. Can be thread-unsafe.
  */
 void Display::VideoAccelVRDP (bool fEnable)
 {
-#if 0
-    /* Supporting all orders. */
-    uint32_t fu32SupportedOrders = ~0;
-#endif
-    
     int c = fEnable?
                 ASMAtomicIncS32 (&mcVideoAccelVRDPRefs):
@@ -823,25 +813,4 @@
     }
 }
-#else
-void Display::VideoAccelVRDP (bool fEnable, uint32_t fu32SupportedOrders)
-{
-    Assert (mfVideoAccelVRDP != fEnable);
-
-    mfVideoAccelVRDP = fEnable;
-
-    if (fEnable)
-    {
-        mfu32SupportedOrders = fu32SupportedOrders;
-    }
-    else
-    {
-        mfu32SupportedOrders = 0;
-    }
-
-    vbvaSetMemoryFlags (mpVbvaMemory, mfVideoAccelEnabled, mfVideoAccelVRDP, mfu32SupportedOrders, maFramebuffers, mcMonitors);
-
-    LogRel(("VBVA: VRDP acceleration has been %s.\n", fEnable? "requested": "disabled"));
-}
-#endif /* VRDP_MC */
 #endif /* VBOX_VRDP */
 
@@ -2074,6 +2043,5 @@
                 }
             }
-#ifdef VRDP_MC
-            /* Inform to VRDP server that the current display update sequence is
+            /* Inform the VRDP server that the current display update sequence is
              * completed. At this moment the framebuffer memory contains a definite
              * image, that is synchronized with the orders already sent to VRDP client.
@@ -2083,5 +2051,4 @@
             Assert (pDisplay->mParent && pDisplay->mParent->consoleVRDPServer());
             pDisplay->mParent->consoleVRDPServer()->SendUpdate (uScreenId, NULL, 0);
-#endif /* VRDP_MC */
         }
     }
Index: trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/Makefile.kmk	(revision 3277)
+++ trunk/src/VBox/Main/Makefile.kmk	(revision 3278)
@@ -22,8 +22,4 @@
 DEPTH = ../../..
 include $(PATH_KBUILD)/header.kmk
-
-ifdef VBOX_WITH_VRDP_MC
-DEFS       += VRDP_MC
-endif
 
 SUBDIRS_AFTER    = testcase 
Index: trunk/src/VBox/Main/RemoteUSBDeviceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/RemoteUSBDeviceImpl.cpp	(revision 3277)
+++ trunk/src/VBox/Main/RemoteUSBDeviceImpl.cpp	(revision 3278)
@@ -52,9 +52,5 @@
  * Initializes the remote USB device object.
  */
-#ifdef VRDP_MC
 HRESULT RemoteUSBDevice::init (uint32_t u32ClientId, VRDPUSBDEVICEDESC *pDevDesc)
-#else
-HRESULT RemoteUSBDevice::init (VRDPUSBDEVICEDESC *pDevDesc)
-#endif /* VRDP_MC  */
 {
     LogFlowMember (("RemoteUSBDevice::init()\n"));
@@ -74,9 +70,5 @@
 
     char id[64];
-#ifdef VRDP_MC
     RTStrPrintf(id, sizeof (id), REMOTE_USB_BACKEND_PREFIX_S "0x%08X&0x%08X", pDevDesc->id, u32ClientId);
-#else
-    RTStrPrintf(id, sizeof (id), REMOTE_USB_BACKEND_PREFIX_S "0x%08X", pDevDesc->id);
-#endif /* VRDP_MC  */
     mAddress      = id;
 
@@ -88,7 +80,5 @@
     mDevId        = pDevDesc->id;
 
-#ifdef VRDP_MC
     mClientId     = u32ClientId;
-#endif /* VRDP_MC  */
 
     setReady (true);
Index: trunk/src/VBox/Main/include/ConsoleImpl.h
===================================================================
--- trunk/src/VBox/Main/include/ConsoleImpl.h	(revision 3277)
+++ trunk/src/VBox/Main/include/ConsoleImpl.h	(revision 3278)
@@ -182,9 +182,5 @@
     static VRDPSERVERCALLBACK *getVrdpServerCallback () { return &sVrdpServerCallback; };
 
-#ifdef VRDP_MC
     void processRemoteUSBDevices (uint32_t u32ClientId, VRDPUSBDEVICEDESC *pDevList, uint32_t cbDevList);
-#else
-    void processRemoteUSBDevices (VRDPUSBDEVICEDESC *pDevList, uint32_t cbDevList);
-#endif /* VRDP_MC */
 
     // callback callers
@@ -406,5 +402,4 @@
     static DECLCALLBACK(int)    drvStatus_Construct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle);
 
-#ifdef VRDP_MC
     int mcAudioRefs;
     volatile uint32_t mcVRDPClients;
@@ -416,12 +411,4 @@
     static DECLCALLBACK(void)   vrdp_InterceptUSB (void *pvUser, uint32_t u32ClientId, PFNVRDPUSBCALLBACK *ppfn, void **ppv);
     static DECLCALLBACK(void)   vrdp_InterceptClipboard (void *pvUser, uint32_t u32ClientId, PFNVRDPCLIPBOARDCALLBACK *ppfn, void **ppv);
-#else
-    static DECLCALLBACK(int)    vrdp_ClientLogon (void *pvUser, const char *pszUser, const char *pszPassword, const char *pszDomain);
-    static DECLCALLBACK(void)   vrdp_ClientConnect (void *pvUser, uint32_t fu32SupportedOrders);
-    static DECLCALLBACK(void)   vrdp_ClientDisconnect (void *pvUser);
-    static DECLCALLBACK(void)   vrdp_InterceptAudio (void *pvUser, bool keepHostAudio);
-    static DECLCALLBACK(void)   vrdp_InterceptUSB (void *pvUser, PFNVRDPUSBCALLBACK *ppfn, void **ppv);
-    static DECLCALLBACK(void)   vrdp_InterceptClipboard (void *pvUser, PFNVRDPCLIPBOARDCALLBACK *ppfn, void **ppv);
-#endif /* VRDP_MC */
 
     static VRDPSERVERCALLBACK   sVrdpServerCallback;
Index: trunk/src/VBox/Main/include/ConsoleVRDPServer.h
===================================================================
--- trunk/src/VBox/Main/include/ConsoleVRDPServer.h	(revision 3277)
+++ trunk/src/VBox/Main/include/ConsoleVRDPServer.h	(revision 3278)
@@ -50,5 +50,4 @@
     void AuthDisconnect (const Guid &uuid, uint32_t u32ClientId);
 
-#ifdef VRDP_MC
     void USBBackendCreate (uint32_t u32ClientId, PFNVRDPUSBCALLBACK *ppfn, void **ppv);
     void USBBackendDelete (uint32_t u32ClientId);
@@ -69,10 +68,4 @@
     void ClipboardCreate (uint32_t u32ClientId, PFNVRDPCLIPBOARDCALLBACK *ppfn, void **ppv);
     void ClipboardDelete (uint32_t u32ClientId);
-#else
-    void CreateUSBBackend (PFNVRDPUSBCALLBACK *ppfn, void **ppv);
-    void DeleteUSBBackend (void);
-
-    void *GetUSBBackendPointer (void);
-#endif /* VRDP_MC */
 
     /*
@@ -86,9 +79,5 @@
     void SendAudioSamples (void *pvSamples, uint32_t cSamples, VRDPAUDIOFORMAT format) const;
     void SendAudioVolume (uint16_t left, uint16_t right) const;
-#ifdef VRDP_MC
     void SendUSBRequest (uint32_t u32ClientId, void *pvParms, uint32_t cbParms) const;
-#else
-    void SendUSBRequest (void *pvParms, uint32_t cbParms) const;
-#endif /* VRDP_MC */
 
     void QueryInfo (uint32_t index, void *pvBuffer, uint32_t cbBuffer, uint32_t *pcbOut) const;
@@ -117,9 +106,5 @@
     static void (VBOXCALL *mpfnVRDPSendAudioSamples)(HVRDPSERVER hserver, void *pvSamples, uint32_t cSamples, VRDPAUDIOFORMAT format);
     static void (VBOXCALL *mpfnVRDPSendAudioVolume) (HVRDPSERVER hserver, uint16_t left, uint16_t right);
-#ifdef VRDP_MC
     static void (VBOXCALL *mpfnVRDPSendUSBRequest)  (HVRDPSERVER hserver, uint32_t u32ClientId, void *pvParms, uint32_t cbParms);
-#else
-    static void (VBOXCALL *mpfnVRDPSendUSBRequest)  (HVRDPSERVER hserver, void *pvParms, uint32_t cbParms);
-#endif /* VRDP_MC */
     static void (VBOXCALL *mpfnVRDPSendUpdate)      (HVRDPSERVER hServer, unsigned uScreenId, void *pvUpdate, uint32_t cbUpdate);
     static void (VBOXCALL *mpfnVRDPQueryInfo)       (HVRDPSERVER hserver, uint32_t index, void *pvBuffer, uint32_t cbBuffer, uint32_t *pcbOut);
@@ -127,5 +112,4 @@
 #endif /* VBOX_VRDP */
 
-#ifdef VRDP_MC
     RTCRITSECT mCritSect;
 
@@ -161,13 +145,4 @@
     void remoteUSBThreadStop (void);
 #endif /* VBOX_WITH_USB */
-#else
-#ifdef VBOX_WITH_USB
-    /* The remote USB backend object is created only if the client
-     * asks for USB channel. The object is created in the vrdp_InterceptUSB
-     * callback.
-     */
-    RemoteUSBBackend *mRemoteUSBBackend;
-#endif /* VBOX_WITH_USB */
-#endif /* VRDP_MC */
 
     /* External authentication library handle. The library is loaded in the
Index: trunk/src/VBox/Main/include/DisplayImpl.h
===================================================================
--- trunk/src/VBox/Main/include/DisplayImpl.h	(revision 3277)
+++ trunk/src/VBox/Main/include/DisplayImpl.h	(revision 3278)
@@ -111,9 +111,5 @@
 
 #ifdef VBOX_VRDP
-#ifdef VRDP_MC
     void VideoAccelVRDP (bool fEnable);
-#else
-    void VideoAccelVRDP (bool fEnable, uint32_t fu32SupportedOrders);
-#endif /* VRDP_MC */
 #endif /* VBOX_VRDP */
 
Index: trunk/src/VBox/Main/include/RemoteUSBBackend.h
===================================================================
--- trunk/src/VBox/Main/include/RemoteUSBBackend.h	(revision 3277)
+++ trunk/src/VBox/Main/include/RemoteUSBBackend.h	(revision 3278)
@@ -38,6 +38,4 @@
 class ConsoleVRDPServer;
 
-#ifdef VRDP_MC
-
 /* How many remote devices can be attached to a remote client. 
  * Normally a client computer has 2-8 physical USB ports, so 16 devices
@@ -54,15 +52,8 @@
         RemoteUSBBackendListable() : pNext (NULL), pPrev (NULL) {};
 };
-#endif /* VRDP_MC */
 
-#ifdef VRDP_MC
 class RemoteUSBBackend: public RemoteUSBBackendListable
-#else
-class RemoteUSBBackend
-#endif /* VRDP_MC */
 {
     public:
-
-#ifdef VRDP_MC
         RemoteUSBBackend(Console *console, ConsoleVRDPServer *server, uint32_t u32ClientId);
         ~RemoteUSBBackend();
@@ -80,19 +71,8 @@
         
         void PollRemoteDevices (void);
-#else
-        RemoteUSBBackend(Console *console, ConsoleVRDPServer *server);
-        ~RemoteUSBBackend();
-
-        int InterceptUSB (PFNVRDPUSBCALLBACK *ppfn, void **ppv);
-        void ReleaseUSB (void);
-
-        REMOTEUSBCALLBACK *GetRemoteBackendCallback (void) { return &mCallback; };
-#endif /* VRDP_MC */
 
     public: /* Functions for internal use. */
-
         ConsoleVRDPServer *VRDPServer (void) { return mServer; };
 
-#ifdef VRDP_MC
         bool pollingEnabledURB (void) { return mfPollURB; }
 
@@ -114,43 +94,9 @@
         bool findUUID (const Guid *pUuid);
         void removeUUID (const Guid *pUuid);
-#else
-        bool pollingEnabledURB (void) { return mfPollURB; };
-
-        void notifyThreadStarted (RTTHREAD self);
-        void notifyThreadFinished (void);
-        bool threadEnabled (void);
-        bool continueThread (void);
-
-        bool needRDL (void);
-        void notifyRDLSent (void);
-
-        int negotiateResponse (VRDPUSBREQNEGOTIATERET *pret);
-
-        int saveDeviceList (void *pvList, uint32_t cbList);
-        bool processRDL (void);
-
-        void request (void);
-        void release (void);
-
-        void waitEvent (unsigned cMillies);
-
-        void addDevice (PREMOTEUSBDEVICE pDevice);
-        void removeDevice (PREMOTEUSBDEVICE pDevice);
-
-        PREMOTEUSBDEVICE deviceFromId (VRDPUSBDEVID id);
-
-        int reapURB (void *pvBody, uint32_t cbBody);
-#endif /* VRDP_MC */
 
     private:
-
-#ifndef VRDP_MC
-        void initMembers (void);
-#endif /* !VRDP_MC */
-
         Console *mConsole;
         ConsoleVRDPServer *mServer;
 
-#ifdef VRDP_MC
         int cRefs;
         
@@ -183,25 +129,4 @@
         
         Guid aGuids[VRDP_MAX_USB_DEVICES_PER_CLIENT];
-#else
-        RTCRITSECT mCritsect;
-        RTSEMEVENT mEvent;
-
-        REMOTEUSBCALLBACK mCallback;
-
-        RTTHREAD mThread;
-
-        bool mfThreadActive;
-        bool mfThreadEnabled;
-        bool mfTerminateThread;
-
-        RDLState menmRDLState;
-
-        void *mpvDeviceList;
-        uint32_t mcbDeviceList;
-
-        PREMOTEUSBDEVICE mpDevices;
-
-        bool mfPollURB;
-#endif /* VRDP_MC */
 };
 
Index: trunk/src/VBox/Main/include/RemoteUSBDeviceImpl.h
===================================================================
--- trunk/src/VBox/Main/include/RemoteUSBDeviceImpl.h	(revision 3277)
+++ trunk/src/VBox/Main/include/RemoteUSBDeviceImpl.h	(revision 3278)
@@ -54,9 +54,5 @@
 
     // public initializer/uninitializer for internal purposes only
-#ifdef VRDP_MC
     HRESULT init(uint32_t u32ClientId, VRDPUSBDEVICEDESC *pDevDesc);
-#else
-    HRESULT init(VRDPUSBDEVICEDESC *pDevDesc);
-#endif /* VRDP_MC */
     void uninit();
 
@@ -81,7 +77,5 @@
 
     uint16_t devId (void) { return mDevId; }
-#ifdef VRDP_MC
     uint32_t clientId (void) { return mClientId; }
-#endif /* VRDP_MC */
 
     bool captured (void) { return mState == USBDeviceState_USBDeviceCaptured; }
@@ -123,7 +117,5 @@
     bool mDirty;
     uint16_t mDevId;
-#ifdef VRDP_MC
     uint32_t mClientId;
-#endif /* VRDP_MC */
 };
 