Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui	(revision 3448)
@@ -291,10 +291,10 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>
 <includes>
-    <include location="local" impldecl="in implementation">VBoxGlobal.h</include>
+    <include location="local" impldecl="in implementation">VBoxProblemReporter.h</include>
 </includes>
 <pixmapinproject/>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui	(revision 3448)
@@ -499,6 +499,6 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 3448)
@@ -1275,6 +1275,6 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui	(revision 3448)
@@ -276,6 +276,6 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>
@@ -288,4 +288,5 @@
     <include location="local" impldecl="in declaration">COMDefs.h</include>
     <include location="local" impldecl="in implementation">VBoxUtils.h</include>
+    <include location="local" impldecl="in implementation">VBoxProblemReporter.h</include>
     <include location="local" impldecl="in implementation">VBoxGlobal.h</include>
 </includes>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 3448)
@@ -291,6 +291,6 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>
@@ -302,5 +302,5 @@
     <include location="global" impldecl="in declaration">qlabel.h</include>
     <include location="global" impldecl="in declaration">qlineedit.h</include>
-    <include location="local" impldecl="in implementation">VBoxGlobal.h</include>
+    <include location="local" impldecl="in implementation">VBoxProblemReporter.h</include>
     <include location="local" impldecl="in implementation">VBoxUtils.h</include>
     <include location="local" impldecl="in implementation">VBoxTakeSnapshotDlg.ui.h</include>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3445)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3448)
@@ -2895,6 +2895,6 @@
         <sender>buttonHelp</sender>
         <signal>clicked()</signal>
-        <receiver>&amp;vboxGlobal()</receiver>
-        <slot>showHelpDialog()</slot>
+        <receiver>&amp;vboxProblem()</receiver>
+        <slot>showHelpHelpDialog()</slot>
     </connection>
 </connections>